HDU 2955 Robberies (01背包)

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 5181    Accepted Submission(s): 1958

Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only
for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then
follow N lines, where line j gives an integer Mj and a floating point number Pj .

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints

0 < T <= 100

0.0 <= P <= 1.0

0 < N <= 100

0 < Mj <= 100

0.0 <= Pj <= 1.0

A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05

Sample Output

2 4 6

Source

IDI Open 2009

Recommend

gaojie

解析:把银行的不被抓概率看作物品的价值,银行的钱数作为物品的重量,转化为01背包问题。最后按钱数从大到小检查,找到一个不被抓的最大钱数。

AC代码:

#include <bits/stdc++.h>
using namespace std;
const int maxn = 105;

double dp[maxn * maxn];
int value[maxn];
double weight[maxn];

int nValue, nKind;

void ZeroOnePack(int cost, double weight){
    for(int i=nValue; i>=cost; i--)
        dp[i] = max(dp[i], dp[i - cost] * weight);
}

int main(){
    #ifdef sxk
        freopen("in.txt", "r", stdin);
    #endif // sxk
    int T;
    double P;
    scanf("%d", &T);
    while(T--){
        scanf("%lf%d", &P, &nKind);
        nValue = 0;
        for(int i=0; i<nKind; i++){
            scanf("%d%lf", &value[i], &weight[i]);
            weight[i] = 1 - weight[i];
            nValue += value[i];
        }
        memset(dp, 0, sizeof(dp));
        dp[0] = 1;
        for(int i=0; i<nKind; i++) ZeroOnePack(value[i], weight[i]);
        int i;
        for(i=nValue; i>=0; i--) if(dp[i] >= 1 - P) break;
        printf("%d\n", i);
    }
    return 0;
}
时间: 2024-10-05 04:58:34

HDU 2955 Robberies (01背包)的相关文章

HDU 2955 Robberies --01背包变形

这题有些巧妙,看了别人的题解才知道做的. 因为按常规思路的话,背包容量为浮点数,,不好存储,且不能直接相加,所以换一种思路,将背包容量与价值互换,即令各银行总值为背包容量,逃跑概率(1-P)为价值,即转化为01背包问题. 此时dp[v]表示抢劫到v块钱成功逃跑的概率,概率相乘. 最后从大到小枚举v,找出概率大于逃跑概率的最大v值,即为最大抢劫的金额. 代码: #include <iostream> #include <cstdio> #include <cstring>

HDU 2955 Robberies (01背包)

Robberies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 11297    Accepted Submission(s): 4190 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that

hdu 2955 Robberies 0-1背包/概率初始化

/*Robberies Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 13854 Accepted Submission(s): 5111 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that the

hdu 2955 Robberies (01背包好题)

Robberies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 31769    Accepted Submission(s): 11527 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that

HDU 2955 Robberies(01 背包)

#include<cstdio> #include<cstring> #include<iostream> #include<algorithm> using namespace std; struct Node { int m; double p; }; Node bank[200]; double dp[100000]; int main() { int t,n; double p; int i,j,k; scanf("%d",&am

HDU 2955 Robberies dp +背包

题目链接~~http://acm.hdu.edu.cn/showproblem.php?pid=2955 题意 : 在不被抓住的情况下,偷的钱最多, 然后题目给的是被抓住的概率~ 就可以考虑在不被抓住的情况下,拿的最多的钱.. 还RT了一回    %>_<% 状态方程: dp[j]=max(dp[j],dp[j-a[i]]*p1[i]); 代码:: 1 #include <iostream> 2 #include <cstdio> 3 #include <cmat

hdu 2955 Robberies(背包DP)

题意: 小偷去抢银行,他母亲很担心. 他母亲希望他被抓的概率真不超过P.小偷打算去抢N个银行,每个银行有两个值Mi.Pi,Mi:抢第i个银行所获得的财产 Pi:抢第i个银行被抓的概率 求最多能抢得多少财产. 思路: 由于概率不是整数,所以不能将其作为背包容量.继续观察,发现Mi是整数,调整思路可发现,可以将财产作为背包容量,求一定财产内的被抓的最小概率.这样只需要判断这个概率是否小于等于P即可. 代码: double P; int N; int m[105]; double p[105]; do

HDU 2955(01背包)

1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <algorithm> 5 #define sc(x) scanf("%d",&(x)) 6 #define pf(x) printf("%d\n", x) 7 #define CL(x, y) memset(x, y, sizeof(x)) 8 #define m

HDU 2955 Robberies (背包)

Description The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a s

【hdu2955】 Robberies 01背包

hdu2955 http://acm.hdu.edu.cn/showproblem.php?pid=2955 题意:盗贼抢银行,给出n个银行,每个银行有一定的资金和抢劫后被抓的概率,在给定一个概率P,表示盗贼愿意冒险抢劫所能承受的最大被抓概率. 思路:首先用1减去被抓概率,得到安全概率.那抢劫了多家银行后的安全概率就是这些银行各自的安全概率连乘起来.其实是01背包的变种, dp[j] 表示获得金额 j 时的安全概率.这里用滚动数组,得方程  dp[j] = max(dp[j], dp[i-a[i